/** @file fsck.cmdline.h
 *  @brief The header file for the command line option parser
 *  generated by GNU Gengetopt version 2.21
 *  http://www.gnu.org/software/gengetopt.
 *  DO NOT modify this file, since it can be overwritten
 *  @author GNU Gengetopt by Lorenzo Bettini */

#ifndef FSCK_CMDLINE_H
#define FSCK_CMDLINE_H

/* If we use autoconf.  */
#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#ifndef FSCK_CMDLINE_PARSER_PACKAGE
/** @brief the program name */
#define FSCK_CMDLINE_PARSER_PACKAGE "para_fsck"
#endif

#ifndef FSCK_CMDLINE_PARSER_VERSION
/** @brief the program version */
#define FSCK_CMDLINE_PARSER_VERSION "0.3.0"
#endif

/** @brief Where the command line options are stored */
struct fsck_args_info
{
  const char *help_help; /**< @brief Print help and exit help description.  */
  const char *version_help; /**< @brief Print version and exit help description.  */
  int loglevel_arg;	/**< @brief set loglevel (0-6) (default='3').  */
  char * loglevel_orig;	/**< @brief set loglevel (0-6) original value given at command line.  */
  const char *loglevel_help; /**< @brief set loglevel (0-6) help description.  */
  char * base_dir_arg;	/**< @brief Full path to the database directory
  containing the table(s) to be checked.
  (default='~/.paraslash/afs_database'.  */
  char * base_dir_orig;	/**< @brief Full path to the database directory
  containing the table(s) to be checked.
  (default='~/.paraslash/afs_database' original value given at command line.  */
  const char *base_dir_help; /**< @brief Full path to the database directory
  containing the table(s) to be checked.
  (default='~/.paraslash/afs_database' help description.  */
  char * dump_dir_arg;	/**< @brief If path is non-empty, para_fsck will write a
  dump of all given tables to the specified
  path. (default='').  */
  char * dump_dir_orig;	/**< @brief If path is non-empty, para_fsck will write a
  dump of all given tables to the specified
  path. original value given at command line.  */
  const char *dump_dir_help; /**< @brief If path is non-empty, para_fsck will write a
  dump of all given tables to the specified
  path. help description.  */
  int no_fsck_flag;	/**< @brief Disable fsck mode. (default=off).  */
  const char *no_fsck_help; /**< @brief Disable fsck mode. help description.  */
  int force_flag;	/**< @brief Force fsck even if the table is dirty.
  Ignored if -n is given. (default=off).  */
  const char *force_help; /**< @brief Force fsck even if the table is dirty.
  Ignored if -n is given. help description.  */
  int dry_run_flag;	/**< @brief Only report problems, don't try to fix them. (default=off).  */
  const char *dry_run_help; /**< @brief Only report problems, don't try to fix them. help description.  */
  
  int help_given ;	/**< @brief Whether help was given.  */
  int version_given ;	/**< @brief Whether version was given.  */
  int loglevel_given ;	/**< @brief Whether loglevel was given.  */
  int base_dir_given ;	/**< @brief Whether base_dir was given.  */
  int dump_dir_given ;	/**< @brief Whether dump_dir was given.  */
  int no_fsck_given ;	/**< @brief Whether no_fsck was given.  */
  int force_given ;	/**< @brief Whether force was given.  */
  int dry_run_given ;	/**< @brief Whether dry_run was given.  */

  char **inputs ; /**< @brief unamed options (options without names) */
  unsigned inputs_num ; /**< @brief unamed options number */
} ;

/** @brief The additional parameters to pass to parser functions */
struct fsck_cmdline_parser_params
{
  int override; /**< @brief whether to override possibly already present options (default 0) */
  int initialize; /**< @brief whether to initialize the option structure fsck_args_info (default 0) */
  int check_required; /**< @brief whether to check that all required options were provided (default 0) */
  int check_ambiguity; /**< @brief whether to check for options already specified in the option structure fsck_args_info (default 0) */
} ;

/** @brief the purpose string of the program */
extern const char *fsck_args_info_purpose;
/** @brief the usage string of the program */
extern const char *fsck_args_info_usage;
/** @brief all the lines making the help output */
extern const char *fsck_args_info_help[];

/**
 * The command line parser
 * @param argc the number of command line options
 * @param argv the command line options
 * @param args_info the structure where option information will be stored
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int fsck_cmdline_parser (int argc, char * const *argv,
  struct fsck_args_info *args_info);

/**
 * The command line parser (version with additional parameters - deprecated)
 * @param argc the number of command line options
 * @param argv the command line options
 * @param args_info the structure where option information will be stored
 * @param override whether to override possibly already present options
 * @param initialize whether to initialize the option structure my_args_info
 * @param check_required whether to check that all required options were provided
 * @return 0 if everything went fine, NON 0 if an error took place
 * @deprecated use fsck_cmdline_parser_ext() instead
 */
int fsck_cmdline_parser2 (int argc, char * const *argv,
  struct fsck_args_info *args_info,
  int override, int initialize, int check_required);

/**
 * The command line parser (version with additional parameters)
 * @param argc the number of command line options
 * @param argv the command line options
 * @param args_info the structure where option information will be stored
 * @param params additional parameters for the parser
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int fsck_cmdline_parser_ext (int argc, char * const *argv,
  struct fsck_args_info *args_info,
  struct fsck_cmdline_parser_params *params);

/**
 * Save the contents of the option struct into a (text) file.
 * This file can be read by the config file parser (if generated by gengetopt)
 * @param filename the file where to save
 * @param args_info the option struct to save
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int fsck_cmdline_parser_file_save(const char *filename,
  struct fsck_args_info *args_info);

/**
 * Print the help
 */
void fsck_cmdline_parser_print_help(void);
/**
 * Print the version
 */
void fsck_cmdline_parser_print_version(void);

/**
 * Allocates dynamically a fsck_cmdline_parser_params structure and initializes
 * all its fields to 0
 * @return the initialized fsck_cmdline_parser_params structure
 */
struct fsck_cmdline_parser_params *fsck_cmdline_parser_params_init(void);

/**
 * Initializes the passed fsck_args_info structure's fields
 * (also set default values for options that have a default)
 * @param args_info the structure to initialize
 */
void fsck_cmdline_parser_init (struct fsck_args_info *args_info);
/**
 * Deallocates the string fields of the fsck_args_info structure
 * (but does not deallocate the structure itself)
 * @param args_info the structure to deallocate
 */
void fsck_cmdline_parser_free (struct fsck_args_info *args_info);

/**
 * Checks that all the required options were specified
 * @param args_info the structure to check
 * @param prog_name the name of the program that will be used to print
 *   possible errors
 * @return
 */
int fsck_cmdline_parser_required (struct fsck_args_info *args_info,
  const char *prog_name);


#ifdef __cplusplus
}
#endif /* __cplusplus */
#endif /* FSCK_CMDLINE_H */
